## hyprutils 0.1.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

set(HYPRUTILS_VERSION "0.1.5")
add_compile_definitions(HYPRUTILS_VERSION="${HYPRUTILS_VERSION}")

project(hyprutils
    VERSION ${HYPRUTILS_VERSION}
    DESCRIPTION "Small C++ library for utilities used across the Hypr* ecosystem"
)

include(CTest)
include(GNUInstallDirs)

set(PREFIX ${CMAKE_INSTALL_PREFIX})
set(INCLUDE ${CMAKE_INSTALL_FULL_INCLUDEDIR})
set(LIBDIR ${CMAKE_INSTALL_FULL_LIBDIR})

configure_file(hyprutils.pc.in hyprutils.pc @ONLY)

set(CMAKE_CXX_STANDARD 23)

if(CMAKE_BUILD_TYPE MATCHES Debug OR CMAKE_BUILD_TYPE MATCHES DEBUG)
    message(STATUS "Configuring hyprutils in Debug")
    add_compile_definitions(HYPRLAND_DEBUG)
else()
    add_compile_options(-O3)
    message(STATUS "Configuring hyprutils in Release")
endif()

file(GLOB_RECURSE SRCFILES CONFIGURE_DEPENDS "src/*.cpp" "include/*.hpp")
file(GLOB_RECURSE PUBLIC_HEADERS CONFIGURE_DEPENDS "include/*.hpp")

find_package(PkgConfig REQUIRED)
pkg_check_modules(deps REQUIRED IMPORTED_TARGET pixman-1)

add_library(hyprutils SHARED ${SRCFILES})
target_include_directories( hyprutils
    PUBLIC "./include"
    PRIVATE "./src"
)
set_target_properties(hyprutils PROPERTIES
    VERSION ${hyprutils_VERSION}
    SOVERSION 0
)
target_link_libraries(hyprutils PkgConfig::deps)

# tests
add_custom_target(tests)

add_executable(hyprutils_memory "tests/memory.cpp")
target_link_libraries(hyprutils_memory PRIVATE hyprutils PkgConfig::deps)
add_test(NAME "Memory" WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests COMMAND hyprutils_memory "memory")
add_dependencies(tests hyprutils_memory)

add_executable(hyprutils_string "tests/string.cpp")
target_link_libraries(hyprutils_string PRIVATE hyprutils PkgConfig::deps)
add_test(NAME "String" WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests COMMAND hyprutils_string "string")
add_dependencies(tests hyprutils_string)

add_executable(hyprutils_signal "tests/signal.cpp")
target_link_libraries(hyprutils_signal PRIVATE hyprutils PkgConfig::deps)
add_test(NAME "Signal" WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests COMMAND hyprutils_signal "signal")
add_dependencies(tests hyprutils_signal)

add_executable(hyprutils_math "tests/math.cpp")
target_link_libraries(hyprutils_math PRIVATE hyprutils PkgConfig::deps)
add_test(NAME "Math" WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests COMMAND hyprutils_math "math")
add_dependencies(tests hyprutils_math)

# Installation
install(TARGETS hyprutils)
install(DIRECTORY "include/hyprutils" DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES ${CMAKE_BINARY_DIR}/hyprutils.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== debian/changelog ===
hyprutils (0.1.5-1) unstable; urgency=medium

  * Initial release. (Closes: #1073158)

 -- Alan M Varghese (NyxTrail) <alan@digistorm.in>  Mon, 01 Jul 2024 05:30:04 +0000

=== debian/control ===
Source: hyprutils
Section: libs
Priority: optional
Maintainer: Alan M Varghese (NyxTrail) <alan@digistorm.in>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libpixman-1-dev,
 pkgconf,
Standards-Version: 4.6.2
Homepage: https://github.com/hyprwm/hyprutils
Vcs-Browser: https://salsa.debian.org/NyxTrail/hyprutils
Vcs-Git: https://salsa.debian.org/NyxTrail/hyprutils.git

Package: libhyprutils-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libhyprutils0 (= ${binary:Version}),
 ${misc:Depends},
Description: Utilities used across the Hyprland ecosystem (development files)
 Hyprutils is a small C++ library for utilities used across the Hyprland
 window manager ecosystem.
 .
 This package contains the development files.

Package: libhyprutils0
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Utilities used across the Hyprland ecosystem (library)
 Hyprutils is a small C++ library for utilities used across the Hyprland
 window manager ecosystem.
 .
 This package contains the binary shared library.

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE:STRING=Release
	-DCMAKE_INSTALL_PREFIX:PATH=/usr
	# -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

=== debian/watch ===
version=4
opts="searchmode=html" \
  https://github.com/hyprwm/hyprutils/tags \
  https://github.com/hyprwm/hyprutils/archive/refs/tags/v(\d+)\.(\d+)\.(\d+)?\.?tar\.gz

## hyprutils 0.7.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

file(READ "${CMAKE_SOURCE_DIR}/VERSION" VER_RAW)
string(STRIP ${VER_RAW} HYPRUTILS_VERSION)
add_compile_definitions(HYPRUTILS_VERSION="${HYPRUTILS_VERSION}")

project(
  hyprutils
  VERSION ${HYPRUTILS_VERSION}
  DESCRIPTION "Small C++ library for utilities used across the Hypr* ecosystem")

include(CTest)
include(GNUInstallDirs)

set(PREFIX ${CMAKE_INSTALL_PREFIX})
set(INCLUDE ${CMAKE_INSTALL_FULL_INCLUDEDIR})
set(LIBDIR ${CMAKE_INSTALL_FULL_LIBDIR})

configure_file(hyprutils.pc.in hyprutils.pc @ONLY)

set(CMAKE_CXX_STANDARD 23)
add_compile_options(
  -Wall
  -Wextra
  -Wpedantic
  -Wno-unused-parameter
  -Wno-unused-value
  -Wno-missing-field-initializers
  -Wno-narrowing
  -Wno-pointer-arith)
set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)

if(CMAKE_BUILD_TYPE MATCHES Debug OR CMAKE_BUILD_TYPE MATCHES DEBUG)
  message(STATUS "Configuring hyprutils in Debug")
  add_compile_definitions(HYPRLAND_DEBUG)
else()
  add_compile_options(-O3)
  message(STATUS "Configuring hyprutils in Release")
endif()

file(GLOB_RECURSE SRCFILES CONFIGURE_DEPENDS "src/*.cpp" "include/*.hpp")
file(GLOB_RECURSE PUBLIC_HEADERS CONFIGURE_DEPENDS "include/*.hpp")

find_package(PkgConfig REQUIRED)
pkg_check_modules(deps REQUIRED IMPORTED_TARGET pixman-1)

add_library(hyprutils SHARED ${SRCFILES})
target_include_directories(
  hyprutils
  PUBLIC "./include"
  PRIVATE "./src")
set_target_properties(hyprutils PROPERTIES VERSION ${hyprutils_VERSION}
                                           SOVERSION 6)
target_link_libraries(hyprutils PkgConfig::deps)

# tests
add_custom_target(tests)

add_executable(hyprutils_memory "tests/memory.cpp")
target_link_libraries(hyprutils_memory PRIVATE hyprutils PkgConfig::deps)
add_test(
  NAME "Memory"
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests
  COMMAND hyprutils_memory "memory")
add_dependencies(tests hyprutils_memory)

add_executable(hyprutils_string "tests/string.cpp")
target_link_libraries(hyprutils_string PRIVATE hyprutils PkgConfig::deps)
add_test(
  NAME "String"
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests
  COMMAND hyprutils_string "string")
add_dependencies(tests hyprutils_string)

add_executable(hyprutils_signal "tests/signal.cpp")
target_link_libraries(hyprutils_signal PRIVATE hyprutils PkgConfig::deps)
add_test(
  NAME "Signal"
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests
  COMMAND hyprutils_signal "signal")
add_dependencies(tests hyprutils_signal)

add_executable(hyprutils_math "tests/math.cpp")
target_link_libraries(hyprutils_math PRIVATE hyprutils PkgConfig::deps)
add_test(
  NAME "Math"
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests
  COMMAND hyprutils_math "math")
add_dependencies(tests hyprutils_math)

add_executable(hyprutils_os "tests/os.cpp")
target_link_libraries(hyprutils_os PRIVATE hyprutils PkgConfig::deps)
add_test(
  NAME "OS"
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests
  COMMAND hyprutils_os "os")
add_dependencies(tests hyprutils_os)

add_executable(hyprutils_filedescriptor "tests/filedescriptor.cpp")
target_link_libraries(hyprutils_filedescriptor PRIVATE hyprutils PkgConfig::deps)
add_test(
  NAME "Filedescriptor"
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests
  COMMAND hyprutils_filedescriptor "filedescriptor")
add_dependencies(tests hyprutils_filedescriptor)

add_executable(hyprutils_animation "tests/animation.cpp")
target_link_libraries(hyprutils_animation PRIVATE hyprutils PkgConfig::deps)
add_test(
  NAME "Animation"
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/tests
  COMMAND hyprutils_animation "utils")
add_dependencies(tests hyprutils_animation)

# Installation
install(TARGETS hyprutils)
install(DIRECTORY "include/hyprutils" DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES ${CMAKE_BINARY_DIR}/hyprutils.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== debian/changelog ===
hyprutils (0.7.0-1) unstable; urgency=medium

  [ alan (NyxTrail) ]
  * New upstream version 0.7.0
  * Breaking ABI changes: updated soversion to 6

 -- Alan M Varghese (NyxTrail) <alan@digistorm.in>  Sun, 04 May 2025 11:39:54 +0000

hyprutils (0.6.0-1) unstable; urgency=medium

  * New upstream version 0.6.0

 -- Alan M Varghese (NyxTrail) <alan@digistorm.in>  Mon, 07 Apr 2025 14:58:04 +0000

hyprutils (0.5.1-1) unstable; urgency=medium

  * New upstream version 0.5.1

 -- Alan M Varghese (NyxTrail) <alan@digistorm.in>  Sun, 02 Mar 2025 09:47:24 +0000

hyprutils (0.2.3-1) unstable; urgency=medium

  * New upstream version 0.2.3
  * Incorporate changes for upstream soversion update
  * Update Standards version to 4.7.0

 -- Alan M Varghese (NyxTrail) <alan@digistorm.in>  Fri, 11 Oct 2024 06:36:56 +0000

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  cmake,
  libpixman-1-dev,
  pkgconf,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://github.com/hyprwm/hyprutils
 Vcs-Browser: https://salsa.debian.org/NyxTrail/hyprutils
 Vcs-Git: https://salsa.debian.org/NyxTrail/hyprutils.git
@@ -18,7 +18,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libhyprutils0 (= ${binary:Version}),
+ libhyprutils6 (= ${binary:Version}),
  ${misc:Depends},
 Description: Utilities used across the Hyprland ecosystem (development files)
  Hyprutils is a small C++ library for utilities used across the Hyprland
@@ -26,7 +26,7 @@
  .
  This package contains the development files.
 
-Package: libhyprutils0
+Package: libhyprutils6
 Architecture: any
 Multi-Arch: same
 Depends:

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifeq ($(DEB_HOST_ARCH),i386)
    export DEB_CXXFLAGS_MAINT_APPEND += -ffloat-store
endif

%:
	dh $@

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
	https://github.com/hyprwm/hyprutils/tags \
	(?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## hyprutils 0.8.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -50,7 +50,7 @@
   PUBLIC "./include"
   PRIVATE "./src")
 set_target_properties(hyprutils PROPERTIES VERSION ${hyprutils_VERSION}
-                                           SOVERSION 6)
+                                           SOVERSION 7)
 target_link_libraries(hyprutils PkgConfig::deps)
 
 # tests

=== debian/changelog ===
hyprutils (0.8.4-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream version 0.8.4. (Closes: #1090839)
  * Breaking ABI changes: updated soversion to 7.
  * Added autopkgtests to run upstream tests.
  * d/watch: migrated to Version 5.

 -- Carl Keinath <carl.keinath@gmail.com>  Wed, 17 Sep 2025 23:04:34 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Section: libs
 Priority: optional
 Maintainer: Alan M Varghese (NyxTrail) <alan@digistorm.in>
-Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
@@ -18,7 +17,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libhyprutils6 (= ${binary:Version}),
+ libhyprutils7 (= ${binary:Version}),
  ${misc:Depends},
 Description: Utilities used across the Hyprland ecosystem (development files)
  Hyprutils is a small C++ library for utilities used across the Hyprland
@@ -26,7 +25,7 @@
  .
  This package contains the development files.
 
-Package: libhyprutils6
+Package: libhyprutils7
 Architecture: any
 Multi-Arch: same
 Depends:

=== debian/watch ===
Version: 5

Template: Github
Owner: hyprwm
Project: hyprutils

## hyprutils 0.10.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -50,7 +50,7 @@
   PUBLIC "./include"
   PRIVATE "./src")
 set_target_properties(hyprutils PROPERTIES VERSION ${hyprutils_VERSION}
-                                           SOVERSION 7)
+                                           SOVERSION 9)
 target_link_libraries(hyprutils PkgConfig::deps)
 
 # tests

=== debian/changelog ===
hyprutils (0.10.0-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * New upstream release (Closes: #1117181)
  * Breaking ABI changes: updated soversion to 9

 -- Carl Keinath <carl.keinath@gmail.com>  Mon, 06 Oct 2025 08:22:04 +0200

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libhyprutils7 (= ${binary:Version}),
+ libhyprutils9 (= ${binary:Version}),
  ${misc:Depends},
 Description: Utilities used across the Hyprland ecosystem (development files)
  Hyprutils is a small C++ library for utilities used across the Hyprland
@@ -25,7 +25,7 @@
  .
  This package contains the development files.
 
-Package: libhyprutils7
+Package: libhyprutils9
 Architecture: any
 Multi-Arch: same
 Depends:

## hyprutils 0.10.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

file(READ "${CMAKE_SOURCE_DIR}/VERSION" VER_RAW)
string(STRIP ${VER_RAW} HYPRUTILS_VERSION)
add_compile_definitions(HYPRUTILS_VERSION="${HYPRUTILS_VERSION}")

project(
  hyprutils
  VERSION ${HYPRUTILS_VERSION}
  DESCRIPTION "Small C++ library for utilities used across the Hypr* ecosystem")

include(CTest)
include(GNUInstallDirs)

set(PREFIX ${CMAKE_INSTALL_PREFIX})
set(INCLUDE ${CMAKE_INSTALL_FULL_INCLUDEDIR})
set(LIBDIR ${CMAKE_INSTALL_FULL_LIBDIR})

configure_file(hyprutils.pc.in hyprutils.pc @ONLY)

set(CMAKE_CXX_STANDARD 23)
add_compile_options(
  -Wall
  -Wextra
  -Wpedantic
  -Wno-unused-parameter
  -Wno-unused-value
  -Wno-missing-field-initializers
  -Wno-narrowing
  -Wno-pointer-arith)
set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)

if(CMAKE_BUILD_TYPE MATCHES Debug OR CMAKE_BUILD_TYPE MATCHES DEBUG)
  message(STATUS "Configuring hyprutils in Debug")
  add_compile_definitions(HYPRLAND_DEBUG)
  set(BUILD_TESTING ON)
else()
  add_compile_options(-O3)
  message(STATUS "Configuring hyprutils in Release")
  set(BUILD_TESTING OFF)
endif()

file(GLOB_RECURSE SRCFILES CONFIGURE_DEPENDS "src/*.cpp" "include/*.hpp")
file(GLOB_RECURSE PUBLIC_HEADERS CONFIGURE_DEPENDS "include/*.hpp")

find_package(PkgConfig REQUIRED)
pkg_check_modules(deps REQUIRED IMPORTED_TARGET pixman-1)

add_library(hyprutils SHARED ${SRCFILES})
target_include_directories(
  hyprutils
  PUBLIC "./include"
  PRIVATE "./src")
set_target_properties(hyprutils PROPERTIES VERSION ${hyprutils_VERSION}
                                           SOVERSION 9)
target_link_libraries(hyprutils PkgConfig::deps)

if(BUILD_TESTING)
  # GTest
  find_package(GTest CONFIG REQUIRED)
  include(GoogleTest)
  file(GLOB_RECURSE TESTFILES CONFIGURE_DEPENDS "tests/*.cpp")
  add_executable(hyprutils_tests ${TESTFILES})

  target_compile_options(hyprutils_tests PRIVATE --coverage)
  target_link_options(hyprutils_tests PRIVATE --coverage)
  
  target_include_directories(
    hyprutils_tests
    PUBLIC "./include"
    PRIVATE "./src" "./src/include" "./protocols" "${CMAKE_BINARY_DIR}")
  target_link_libraries(hyprutils_tests PRIVATE hyprutils GTest::gtest_main
                                                       PkgConfig::deps)
  gtest_discover_tests(hyprutils_tests)

  # Add coverage to hyprutils for test builds
  target_compile_options(hyprutils PRIVATE --coverage)
  target_link_options(hyprutils PRIVATE --coverage)
endif()

# Installation
install(TARGETS hyprutils)
install(DIRECTORY "include/hyprutils" DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES ${CMAKE_BINARY_DIR}/hyprutils.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== debian/changelog ===
hyprutils (0.10.4-1) unstable; urgency=medium

  [ Carl Keinath ]
  * New upstream release (Closes: #1120292)
  * d/tests:
    - port testsuite to gTest
    - disable i18n/Locale test

  [ Chow Loong Jin ]
  * Salvage package (Closes: #1120660)
  * d/control: Update maintainer to Hyprland team

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 05 Dec 2025 21:25:08 +0800

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,11 @@
 Source: hyprutils
 Section: libs
 Priority: optional
-Maintainer: Alan M Varghese (NyxTrail) <alan@digistorm.in>
+Maintainer: Debian Hyprland Maintainers <team+hyprland@tracker.debian.org>
+Uploaders:
+ Alan M Varghese (NyxTrail) <alan@digistorm.in>,
+ Carl Keinath <carl.keinath@gmail.com>,
+ Chow Loong Jin <hyperair@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
  cmake,

## hyprutils 0.11.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -52,7 +52,7 @@
   PUBLIC "./include"
   PRIVATE "./src")
 set_target_properties(hyprutils PROPERTIES VERSION ${hyprutils_VERSION}
-                                           SOVERSION 9)
+                                           SOVERSION 10)
 target_link_libraries(hyprutils PkgConfig::deps)
 
 if(BUILD_TESTING)

=== debian/changelog ===
hyprutils (0.11.0-3) unstable; urgency=medium

  * d/tests/control: add Restrictions: allow-stderr (Closes: #1124048)
  * d/control: bump Standards-Version to 4.7.3

 -- Carl Keinath <carl.keinath@gmail.com>  Sat, 27 Dec 2025 07:11:55 +0100

hyprutils (0.11.0-2) unstable; urgency=medium

  * Reupload to unstable

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 16 Dec 2025 16:12:25 +0800

hyprutils (0.11.0-1) experimental; urgency=medium

  * Update Vcs-* fields to point to hyprland-team
  * New upstream version 0.11.0
  * Rename package for soname bump

 -- Chow Loong Jin <hyperair@debian.org>  Fri, 12 Dec 2025 21:42:30 +0800

=== debian/control ===
--- 
+++ 
@@ -11,17 +11,17 @@
  cmake,
  libpixman-1-dev,
  pkgconf,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://github.com/hyprwm/hyprutils
-Vcs-Browser: https://salsa.debian.org/NyxTrail/hyprutils
-Vcs-Git: https://salsa.debian.org/NyxTrail/hyprutils.git
+Vcs-Browser: https://salsa.debian.org/hyprland-team/hyprutils
+Vcs-Git: https://salsa.debian.org/hyprland-team/hyprutils.git
 
 Package: libhyprutils-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
 Depends:
- libhyprutils9 (= ${binary:Version}),
+ libhyprutils10 (= ${binary:Version}),
  ${misc:Depends},
 Description: Utilities used across the Hyprland ecosystem (development files)
  Hyprutils is a small C++ library for utilities used across the Hyprland
@@ -29,7 +29,7 @@
  .
  This package contains the development files.
 
-Package: libhyprutils9
+Package: libhyprutils10
 Architecture: any
 Multi-Arch: same
 Depends:

=== debian/tests/control ===
Tests: upstream-tests
Depends: @, @builddeps@, libgtest-dev
Restrictions: allow-stderr
